Index: /trunk/lib/App.inc.php
===================================================================
--- /trunk/lib/App.inc.php	(revision 562)
+++ /trunk/lib/App.inc.php	(revision 563)
@@ -122,5 +122,5 @@
 
         // DB credentials should be set as apache environment variables in httpd.conf, readable only by root.
-        'db_server' => 'localhost',
+        'db_server' => null,
         'db_name' => null,
         'db_user' => null,
Index: /trunk/lib/Auth_File.inc.php
===================================================================
--- /trunk/lib/Auth_File.inc.php	(revision 562)
+++ /trunk/lib/Auth_File.inc.php	(revision 563)
@@ -260,7 +260,4 @@
             $user_in_trusted_network = true;
             $app->logMsg(sprintf('User %s accessing from trusted network %s', $_SESSION['_auth_file'][$this->_ns]['username'], $trusted_net), LOG_DEBUG, __FILE__, __LINE__);
-        } else if (preg_match('/proxy.aol.com$/i', getRemoteAddr(true))) {
-            $user_in_trusted_network = true;
-            $app->logMsg(sprintf('User %s accessing from trusted network proxy.aol.com', $_SESSION['_auth_file'][$this->_ns]['username']), LOG_DEBUG, __FILE__, __LINE__);
         } else {
             $user_in_trusted_network = false;
Index: /trunk/lib/Auth_SQL.inc.php
===================================================================
--- /trunk/lib/Auth_SQL.inc.php	(revision 562)
+++ /trunk/lib/Auth_SQL.inc.php	(revision 563)
@@ -525,5 +525,5 @@
 
             // Update the login counter table with this login access. Convert IP to binary.
-            // TODO: after MySQL 5.0.23 is released this query could benefit from INSERT DELAYED.
+            // TODO: this query could benefit from INSERT DELAYED.
             $db->query("
                 INSERT INTO " . $this->_params['db_login_table'] . " (
@@ -558,5 +558,5 @@
      *  - total logged-in time is not greater than login_timeout
      *  - idle time is not greater than idle_timeout
-     *  - remote address is the same as the login remote address (aol users excluded).
+     *  - remote address is the same as the login remote address
      *
      * @access public
@@ -588,5 +588,5 @@
         }
 
-        // Tesing login should occur once. This is the first time. Set flag.
+        // Testing login should occur once. This is the first time. Set flag.
         $this->_authentication_tested = true;
 
@@ -598,9 +598,4 @@
                 ($this->get('user_id') ? $this->get('user_id') . ' (' .  $this->get('username') . ')' : 'unknown'),
                 $trusted_net
-            ), LOG_DEBUG, __FILE__, __LINE__);
-        } else if (preg_match('/proxy.aol.com$/i', getRemoteAddr(true))) {
-            $user_in_trusted_network = true;
-            $app->logMsg(sprintf('User_id %s accessing from trusted network proxy.aol.com',
-                ($this->get('user_id') ? $this->get('user_id') . ' (' .  $this->get('username') . ')' : 'unknown')
             ), LOG_DEBUG, __FILE__, __LINE__);
         } else {
@@ -670,5 +665,5 @@
                     //   1. match_remote_ip config is enabled
                     //   2. user is not match_remote_ip_exempt (set in the user_data, or in the match_remote_ip_exempt_usernames list)
-                    //   3. the user is connecting from a trusted network (their IP is listed in the trusted_networks or from *.proxy.aol.com)
+                    //   3. the user is connecting from a trusted network (their IP is listed in the trusted_networks)
                     $expire_reasons[] = sprintf('remote_ip not matched (%s != %s)', $_SESSION['_auth_sql'][$this->_ns]['remote_ip'], getRemoteAddr());
                 } else {
Index: /trunk/lib/DB.inc.php
===================================================================
--- /trunk/lib/DB.inc.php	(revision 562)
+++ /trunk/lib/DB.inc.php	(revision 563)
@@ -147,6 +147,11 @@
         }
 
+        if (!$this->getParam('db_server')) {
+            // If db_server not specified, assume localhost.
+            $this->setParam('db_server', 'localhost');
+        }
+
         // Connect to database. Always create a new link to the server.
-        // Connection errors are surpressed so we can do our own error management below.
+        // Connection errors are suppressed so we can do our own error management below.
         if ($this->dbh = @mysql_connect($this->getParam('db_server'), $this->getParam('db_user'), $this->getParam('db_pass'), true)) {
             // Select database