Index: /trunk/css/reset.inc.css
===================================================================
--- /trunk/css/reset.inc.css	(revision 635)
+++ /trunk/css/reset.inc.css	(revision 635)
@@ -0,0 +1,48 @@
+/* http://meyerweb.com/eric/tools/css/reset/
+   v2.0 | 20110126
+   License: none (public domain)
+*/
+
+html, body, div, span, applet, object, iframe,
+h1, h2, h3, h4, h5, h6, p, blockquote, pre,
+a, abbr, acronym, address, big, cite, code,
+del, dfn, em, img, ins, kbd, q, s, samp,
+small, strike, strong, sub, sup, tt, var,
+b, u, i, center,
+dl, dt, dd, ol, ul, li,
+fieldset, form, label, legend,
+table, caption, tbody, tfoot, thead, tr, th, td,
+article, aside, canvas, details, embed,
+figure, figcaption, footer, header, hgroup,
+menu, nav, output, ruby, section, summary,
+time, mark, audio, video {
+	margin: 0;
+	padding: 0;
+	border: 0;
+	font-size: 100%;
+	font: inherit;
+	vertical-align: baseline;
+}
+/* HTML5 display-role reset for older browsers */
+article, aside, details, figcaption, figure,
+footer, header, hgroup, menu, nav, section {
+	display: block;
+}
+body {
+	line-height: 1;
+}
+ol, ul {
+	list-style: none;
+}
+blockquote, q {
+	quotes: none;
+}
+blockquote:before, blockquote:after,
+q:before, q:after {
+	content: '';
+	content: none;
+}
+table {
+	border-collapse: collapse;
+	border-spacing: 0;
+}
Index: /trunk/lib/PageNumbers.inc.php
===================================================================
--- /trunk/lib/PageNumbers.inc.php	(revision 634)
+++ /trunk/lib/PageNumbers.inc.php	(revision 635)
@@ -45,7 +45,7 @@
     public $first_item;        // The counter for the first item on this page (zero index).
     public $last_item;         // The counter for the last item on this page (zero index).
-    public $max_num_links = 9; // The max number of links to show on page (odd numbers look best).
+    public $max_num_links = 5; // The max number of links to show on page (odd numbers look best).
     protected $_num_links;        // The number of links to show on page.
-    protected $_per_page = 25;    // Items per page.
+    protected $_per_page = 50;    // Items per page.
 
     // Flags to ensure all necessary values have been set before calling calculate().
Index: /trunk/lib/SortOrder.inc.php
===================================================================
--- /trunk/lib/SortOrder.inc.php	(revision 634)
+++ /trunk/lib/SortOrder.inc.php	(revision 635)
@@ -62,5 +62,5 @@
         $images_path = $app->getParam('images_path') ? $app->getParam('images_path') : '/admin/_widgets';
         $this->asc_widget = sprintf('<img src="%s/sort_ascending.gif" alt="%s" width="11" height="7" border="0" />', $images_path, _("Ascending"));
-        $this->desc_widget = sprintf('<img src="%s/sort_descending.gif" alt="%s" width="11" height="7" border="0" />', $images_path, _("Ascending"));
+        $this->desc_widget = sprintf('<img src="%s/sort_descending.gif" alt="%s" width="11" height="7" border="0" />', $images_path, _("Descending"));
 
         // Setup prefs object.
Index: /trunk/lib/Validator.inc.php
===================================================================
--- /trunk/lib/Validator.inc.php	(revision 634)
+++ /trunk/lib/Validator.inc.php	(revision 635)
@@ -319,5 +319,5 @@
     * @param   string   $file  Filename to log (usually __FILE__)
     * @param   int      $line  Line number to log (usually __LINE__)
-    * @return  const           One of the constant values: Validate::EMAIL_SUCCESS|Validate::EMAIL_REGEX_FAIL|Validate::EMAIL_LENGTH_FAIL|Validate::EMAIL_MX_FAIL
+    * @return  const           One of the constant values: Validator::EMAIL_SUCCESS|Validator::EMAIL_REGEX_FAIL|Validator::EMAIL_LENGTH_FAIL|Validator::EMAIL_MX_FAIL
     * @author  Quinn Comendant <quinn@strangecode.com>
     */
@@ -441,5 +441,5 @@
     * http://en.wikipedia.org/wiki/Luhn_algorithm
     *
-    * @param  string  $val   The input data to validate..
+    * @param  string  $val   The input data to validate.
     * @param  string  $cc_num      Card number to verify.
     * @param  string  $cc_type     Optional, card type to do specific checks.